#!/usr/bin/python
# -*- coding: utf-8 -*-

# Copyright (C) 2011  Free Software Laboratory, Near East University.

# Chameleon is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Chameleon is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# NOTE: Since this is a dirty test script, it *DOES NOT* handle errors.

import libxml2
import libxslt
import os
import sys

if __name__ == "__main__":

    if (len(sys.argv) != 4):
        print "Usage: "+sys.argv[0]+" <xslt> <xml> <output>"
        sys.exit(1)

    # get file paths
    xslt_path = sys.argv[1]
    xml_path = sys.argv[2]
    output_path = sys.argv[3]

    # parse xslt file
    # parse stylesheet from parsed xslt
    xslt_doc = libxml2.parseFile(xslt_path)
    style_sheet = libxslt.parseStylesheetDoc(xslt_doc)

    # parse xml file which is to be transformed
    xml_doc = libxml2.parseFile(xml_path)

    # apply stylesheet to parsed xml document
    result = style_sheet.applyStylesheet(xml_doc, None)

    # save transformed xml document as output_file
    if not os.path.isfile(output_file):
        style_sheet.saveResultToFilename(output_file, result, 0)

    # free up documents
    style.freeStylesheet()
    doc.freeDoc()
    result.freeDoc()

